利用C#进行AutoCAD的二次开发(转)

版权声明:本文为博主原创文章,遵循 CC 4.0 by-sa 版权协议,转载请附上原文出处链接和本声明。
本文链接:https://blog.csdn.net/spw55381155/article/details/79894765


众所周知,对AutoCAD进行二次开发用到的主要工具有:ObjectArx,VBA,VLisp。但它们的优缺点是显而易见的:ObjectArx功能强大,编程效率高,但它的缺点是编程者必须掌握VC++,而这门语言非常的难学;VBA和VLisp虽然简单易上手,但它们对于开发大型的程序好象无能为力。那究竟有没有一种语言能结合它们的优点而尽量避免它们的缺点呢? 回答是肯定的,那就是微软新推出的21世编程语言C#。关于C#的详细介绍,大家可以参考有关的文章。
  C#是通过AutoCAD ActiveX 这座桥梁来和AutoCAD之间进行通讯的。AutoCAD ActiveX 使用户能够从 AutoCAD 的内部或外部以编程方式来操作 AutoCAD。它是通过将 AutoCAD 对象显示到“外部世界”来做到这一点的。一旦这些对象被显示,许多不同的编程语言和环境就可以访问它们。关于AutoCAD ActiveX 的情况,大家可以参考AutoCAD自带的帮助。
  呵呵,说了这么多无聊的,还是让我们通过一个具体的例子来说明怎样利用C#进行AutoCAD的二次开发吧。在介绍例子之前先讲一下有关的配置:
(1)Visual Studio .net (2003和2002都可以,我用的是2002)

(2)AutoCAD2000以上版本(我用的是2004)
  这个例子非常简单,就是通过C#建立的窗体来启动AutoCAD并画一条直线。下面是编程的具体步骤:
(1)通过Visual Studio .net 建立一C#的windows应用程序。
(2)在“解决方案资源管理器”中右击“引用”标签,在弹出的菜单中选择“添加引用”,在“添加引用”对话框中选择“com"选项卡下的下拉列表框中的“AutoCAD 2004 Type Library"项(注意:不同版本的CAD的数字不同),单击右边的“选择”按钮,最后单击下面的“确定”按钮。
(3)在C#窗体中加入两个文本框和一个按钮,分别用于输入直线起点、终点的坐标和在CAD中画直线。下面主要解释一下添加的代码。
(a)在程序的开头加入:using AutoCAD;//导入AutoCAD引用空间
(b)在窗体的变量声明部分加入: private AcadApplication a;//声明AutoCAD对象
(c)在窗体的构造函数部分加入:a=new AcadApplicationClass();//创建AutoCAD对象
a.Visible=true;//使AutoCAD可见
(d)在按钮的消息处理函数中加入:
double[] startPoint=new double[3]; //声明直线起点坐标
double[] endPoint=new double[3];//声明直线终点坐标
string[] str=textBox1.Text.Split(',');

//取出直线起点坐标输入文本框的值,文本框的输入模式为"x,y,z"
for(int i=0;i<3;i++)
startPoint[i]=Convert.ToDouble(str[i]);//将str数组转为double型 
    str=textBox2.Text.Split(',');//取出直线终点坐标输入文本框的值
for(int i=0;i<3;i++)
endPoint[i]=Convert.ToDouble(str[i]);
a.ActiveDocument.ModelSpace.AddLine(startPoint,endPoint);//在AutoCAD中画直线
   a.Application.Update();//更新显示
好了,简单吧,你可以试着编译一下。关于上面一些语句的用法,我会在下一讲中作详细介绍。

利用C#进行AutoCAD的二次开发(二)


利用C#进行AutoCAD的二次开发(二)

C#才鸟

大家好,今天我继续给各位介绍利用C#进行AutoCAD的二次开发。在这一讲中,主要介绍上一讲例子中存在的问题。

在上一次的例子中我是通过引用AutoCAD 2004 Type Library来进行C#与AutoCAD之间的通信,但这种方法存在两个致命的缺点。第一个缺点是每次调试程序的时候C#都要重新启动AutoCAD,如果调试的次数非常多(比如跟踪错误然后调试),那么编程的效率就很低,因为启动一次CAD还是需要较长的时间。相对于第一个缺点,第二个缺点则更要命。由于.NET本身的问题,Interop.AutoCAD.dll文件(就是通过它才实现了C#与AutoCAD之间的通信)存在着一些bug,因此虽然有时你的代码是完全正确的,但C#编译器还是抛出莫名其妙的错误。那不是完蛋了吗?我曾经有一阶段就因为这两个要命的东东差一点放弃了C#而想改学ObjectArx了,呵呵,不过还是运气好,我偶尔一次在网上看了一篇外国人写的文章,他专门介绍了这两个问题的解决办法。下面就来解决这两个问题。

首先来看第二个难题,按以下步骤来进行:

1. 随便用Visual Studio .NET建立一个C#应用程序,然后按照上一篇文章中的设置加入AutoCAD 2004 Type Library,然后不加入任何代码,编译你的程序。

2. 在Visual Studio .NET命令行工具下用ildasm.exe(这个工具可以在Visual Studio .NET安装光盘中找到)把Interop.AutoCAD.dll文件(这个文件在步骤1中生成的项目的Bin\Release文件夹中)编译成中间语言Interop. AutoCAD.il。注意:在步骤1中建立的项目的编译设置为Release模式。

ildasm.exe /source Interop.AutoCAD.dll /output=Interop. AutoCAD.il

又要注意了:把ildasm.exe,Interop.AutoCAD.dll放在同一目录下。

3.在记事本中打开Interop. AutoCAD.il文件,然后查找结尾是“SinkHelper”而开头为 ".class private auto ansi sealed _DAcad“的语句,把语句中的private 改为public,然后保存Interop. AutoCAD.il文件。

4.使用ilasm.exe把Interop. AutoCAD.il文件编译为Interop.AutoCAD.dll文件,同样是在Visual Studio .NET命令行工具下进行。

ilasm.exe /resource=Interop.AutoCAD.res /dll Interop.AutoCAD.il /output=Interop. AutoCAD.dll

Interop.AutoCAD.res文件是在步骤1中生成的。

5.显然你不愿意每次编写应用程序时都通过上一篇文章中介绍的方法来加入Interop. AutoCAD.dll,那太麻烦了。你可以用下面的方法来让程序自动加入该文件:找到C:\Program Files\Microsoft.NET\ Primary Interop Assemblies 文件夹,然后把上面生成的

Interop.AutoCAD.dll文件拷贝进去。

好了,第二个问题解决了,接下来看第一个。

在VBA中,编程者可以使用GetObject函数来获得当前活动的AutoCAD对象,但在C#中却没有,为了这个函数我几乎把MSDN给翻遍了,然后去各种C#论坛问各位高手,结果都没得到解决,呵呵,可能国内使用C#的人比较少吧。还是在老外的论坛上看到了一篇就是讲这个问题的文章才把这个难题给解决了。使用下面的语句就可以获得当前活动的AutoCAD对象了:

(AcadApplication)Marshal.GetActiveObject("AutoCAD.Application.16")

(对于CAD2000和CAD2002,则把16改为15)

当然以上语句必须在AutoCAD打开的情况下才能使用,否则会发生错误,对于AutoCAD没打开的情况,可以使用上一篇文章的方法来处理。完整的连接AutoCAD与C#的源程序如下所示:

using System;

using AutoCAD;

using System.Runtime.InteropServices;

namespace AcadExample

{

public class AutoCADConnector : IDisposable

{

private AcadApplication _application;

private bool _initialized;

private bool _disposed;

public AutoCADConnector()

{

try

{

// Upon creation, attempt to retrieve running instance

_application = (AcadApplication)Marshal.GetActiveObject("AutoCAD.Application.16");

}

catch

{

try

{

// Create an instance and set flag to indicate this

_application = new AcadApplicationClass();

_initialized = true;

}

catch

{

throw;

}

}

}

// If the user doesn't call Dispose, the

// garbage collector will upon destruction

~AutoCADConnector()

{

Dispose(false);

}

public AcadApplication Application

{

get

{

// Return our internal instance of AutoCAD

return _application;

}

}

// This is the user-callable version of Dispose.

// It calls our internal version and removes the

// object from the garbage collector's queue.

public void Dispose()

{

Dispose(true);

GC.SuppressFinalize(this);

}

// This version of Dispose gets called by our

// destructor.

protected virtual void Dispose(bool disposing)

{

// If we created our AutoCAD instance, call its

// Quit method to avoid leaking memory.

if(!this._disposed && _initialized)

_application.Quit();

_disposed = true;

}

}

}

利用Visual Studio.net 把上面的程序编译成一个类库,你就可以在以后的程序中使用它了,下面的这个例子说明了它的用法。(首先把AcadExample类库包含在项目中)

using System;

using AcadExample;

using AutoCAD;

namespace ConsoleApplication6

{

class Class1

{

[STAThread]

static void Main(string[] args)

{

using (AutoCADConnector connector = new AutoCADConnector())

{

Console.WriteLine(connector.Application.ActiveDocument.Name);

}

Console.ReadLine();

}

}

}

这个例子是在C#窗口中显示AutoCAD中当前文档的标题。


在C#中使用ObjectDBX技术从未打开图形中获得图块的信息


在C#中使用ObjectDBX技术从未打开图形中获得图块的信息

从未打开图形中能获得图块的信息吗?回答是肯定的。下面就来说明具体的实现方法。

要求:

n 会用C#编程

n 读过我写的“利用C#进行AutoCAD的二次开发”

开始:

n 在visual studio.net中新建一C#控制台程序

n 在引用选项卡中添加下列类库:

l interop.AutoCAD.dll

l AcadExample.dll

l ObjectDBX16(在“解决方案资源管理器”中右击“引用”标签,在弹出的菜单中选择“添加引用”,在“添加引用”对话框中选择“com"选项卡下的下拉列表框中的“AutoCAD/ObjectDBX Common 16.0 Type Library"项)

然后键入以下代码:

1: using System;

2: using AutoCAD;

3: using dbx = AXDBLib;

4: using AcadExample;

5:

6: namespace ConsoleApplication1

7: {

8: /// <summary>

9: /// Summary description for Class1.

10: /// </summary>

11: class Class1

12: {

13: /// <summary>

14: /// The main entry point for the application.

15: /// </summary>

16: [STAThread]

17: static void Main(string[] args)

18: {

19: using (AutoCADConnector connector = new AutoCADConnector())

20: {

21: string progid = "ObjectDBX.AxDbDocument.16"

//注意,这是AutoCAD2004的写法,

//若是AutoCAD2002和AutoCAD2000i是”ObjectDBX.AxDbDocument.1“

22: AcadApplication acadApp = connector.Application;

23: dbx.AxDbDocument dbxDoc;

24: dbxDoc = (dbx.AxDbDocument)acadApp.GetInterfaceObject(progid);

25: dbxDoc.Open(@"F:\Test.dwg");

26: foreach (dbx.AcadEntity entity in dbxDoc.ModelSpace)

27: {

28: if (entity.EntityName == "AcDbBlockReference")

//判断实体是否是块参照

29: {

30: dbx.AcadBlockReference blkRef;

31: blkRef = (dbx.AcadBlockReference)entity;

//将是块参照的实体强制转换为块参照类型

32: object[] atts = (object[])blkRef.GetAttributes();

//获取块参照中的属性(为对象类型)

33: for (int i = 0; i < atts.Length; i++) //遍历块参照属性

34: {

35: dbx.AcadAttributeReference att;

36: att = (dbx.AcadAttributeReference)atts[i];

//将块参照属性(对象类型)强制转换为块参照属性类型

37: Console.WriteLine("Tag: {0}\tValue: {1}\n",

38: att.TagString,

39: att.TextString);//显示块参照属性的Tag和Text的值

40: }

41: }

42: }

43: Console.ReadLine();

44: }

45: }

46: }

47: }

第一个要注意的是第三行,使用了一个别名。因为AutoCAD和ObjectDBX命名空间有许多相同的类名,因此,你必须使用全名,而不能使用简写的形式,但ObjectDBX写起来比较麻烦,所以用别名dbx来使输入方便一些。

程序前面部分的代码,你可以参考我写的“利用C#进行AutoCAD的二次开发“这篇文章。让我们来看第21行,程序定义了一个字符串progid,作为第24句的函数GetInterfaceObject的参数,该函数是用来产生一个AxDbDocument对象。但要注意, GetInterfaceObject函数返回的类型是object,所以你必须用强制转换把它变为AxDbDocument类。然后在第25行使用24行产生的AxDbDocument对象来”打开“一个.dwg文件(其实没有打开),需要注意的是这个文件的路径必须是正确的。这个文件就是我们要获得的块信息所在的文件。

由于ObjectDBX 没有选择集,所以只有通过遍历文件的模型空间来获得块的信息(26-28行)。

余下语句的说明我已经写在程序的注释中了。

你可以发现ObjectDBX的工作原理在C#中与VBA是类似的,只不过要进行必要的类型转换。

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
蓝色力量注:
对于文章中提到的对于Interop. AutoCAD.dll需要反编译、修改、再编译的过程,在VS2005中已经不需要这样操作,VS2005已经把private改成了public。


众所周知,对AutoCAD进行二次开发用到的主要工具有:ObjectArx,VBA,VLisp。但它们的优缺点是显而易见的:ObjectArx功能强大,编程效率高,但它的缺点是编程者必须掌握VC++,而这门语言非常的难学;VBA和VLisp虽然简单易上手,但它们对于开发大型的程序好象无能为力。那究竟有没有一种语言能结合它们的优点而尽量避免它们的缺点呢? 回答是肯定的,那就是微软新推出的21世编程语言C#。关于C#的详细介绍,大家可以参考有关的文章。
  C#是通过AutoCAD ActiveX 这座桥梁来和AutoCAD之间进行通讯的。AutoCAD ActiveX 使用户能够从 AutoCAD 的内部或外部以编程方式来操作 AutoCAD。它是通过将 AutoCAD 对象显示到“外部世界”来做到这一点的。一旦这些对象被显示,许多不同的编程语言和环境就可以访问它们。关于AutoCAD ActiveX 的情况,大家可以参考AutoCAD自带的帮助。
  呵呵,说了这么多无聊的,还是让我们通过一个具体的例子来说明怎样利用C#进行AutoCAD的二次开发吧。在介绍例子之前先讲一下有关的配置:
(1)Visual Studio .net (2003和2002都可以,我用的是2002)

(2)AutoCAD2000以上版本(我用的是2004)
  这个例子非常简单,就是通过C#建立的窗体来启动AutoCAD并画一条直线。下面是编程的具体步骤:
(1)通过Visual Studio .net 建立一C#的windows应用程序。
(2)在“解决方案资源管理器”中右击“引用”标签,在弹出的菜单中选择“添加引用”,在“添加引用”对话框中选择“com"选项卡下的下拉列表框中的“AutoCAD 2004 Type Library"项(注意:不同版本的CAD的数字不同),单击右边的“选择”按钮,最后单击下面的“确定”按钮。
(3)在C#窗体中加入两个文本框和一个按钮,分别用于输入直线起点、终点的坐标和在CAD中画直线。下面主要解释一下添加的代码。
(a)在程序的开头加入:using AutoCAD;//导入AutoCAD引用空间
(b)在窗体的变量声明部分加入: private AcadApplication a;//声明AutoCAD对象
(c)在窗体的构造函数部分加入:a=new AcadApplicationClass();//创建AutoCAD对象
a.Visible=true;//使AutoCAD可见
(d)在按钮的消息处理函数中加入:
double[] startPoint=new double[3]; //声明直线起点坐标
double[] endPoint=new double[3];//声明直线终点坐标
string[] str=textBox1.Text.Split(',');

//取出直线起点坐标输入文本框的值,文本框的输入模式为"x,y,z"
for(int i=0;i<3;i++)
startPoint[i]=Convert.ToDouble(str[i]);//将str数组转为double型 
    str=textBox2.Text.Split(',');//取出直线终点坐标输入文本框的值
for(int i=0;i<3;i++)
endPoint[i]=Convert.ToDouble(str[i]);
a.ActiveDocument.ModelSpace.AddLine(startPoint,endPoint);//在AutoCAD中画直线
   a.Application.Update();//更新显示
好了,简单吧,你可以试着编译一下。关于上面一些语句的用法,我会在下一讲中作详细介绍。

利用C#进行AutoCAD的二次开发(二)


利用C#进行AutoCAD的二次开发(二)

C#才鸟

大家好,今天我继续给各位介绍利用C#进行AutoCAD的二次开发。在这一讲中,主要介绍上一讲例子中存在的问题。

在上一次的例子中我是通过引用AutoCAD 2004 Type Library来进行C#与AutoCAD之间的通信,但这种方法存在两个致命的缺点。第一个缺点是每次调试程序的时候C#都要重新启动AutoCAD,如果调试的次数非常多(比如跟踪错误然后调试),那么编程的效率就很低,因为启动一次CAD还是需要较长的时间。相对于第一个缺点,第二个缺点则更要命。由于.NET本身的问题,Interop.AutoCAD.dll文件(就是通过它才实现了C#与AutoCAD之间的通信)存在着一些bug,因此虽然有时你的代码是完全正确的,但C#编译器还是抛出莫名其妙的错误。那不是完蛋了吗?我曾经有一阶段就因为这两个要命的东东差一点放弃了C#而想改学ObjectArx了,呵呵,不过还是运气好,我偶尔一次在网上看了一篇外国人写的文章,他专门介绍了这两个问题的解决办法。下面就来解决这两个问题。

首先来看第二个难题,按以下步骤来进行:

1. 随便用Visual Studio .NET建立一个C#应用程序,然后按照上一篇文章中的设置加入AutoCAD 2004 Type Library,然后不加入任何代码,编译你的程序。

2. 在Visual Studio .NET命令行工具下用ildasm.exe(这个工具可以在Visual Studio .NET安装光盘中找到)把Interop.AutoCAD.dll文件(这个文件在步骤1中生成的项目的Bin\Release文件夹中)编译成中间语言Interop. AutoCAD.il。注意:在步骤1中建立的项目的编译设置为Release模式。

ildasm.exe /source Interop.AutoCAD.dll /output=Interop. AutoCAD.il

又要注意了:把ildasm.exe,Interop.AutoCAD.dll放在同一目录下。

3.在记事本中打开Interop. AutoCAD.il文件,然后查找结尾是“SinkHelper”而开头为 ".class private auto ansi sealed _DAcad“的语句,把语句中的private 改为public,然后保存Interop. AutoCAD.il文件。

4.使用ilasm.exe把Interop. AutoCAD.il文件编译为Interop.AutoCAD.dll文件,同样是在Visual Studio .NET命令行工具下进行。

ilasm.exe /resource=Interop.AutoCAD.res /dll Interop.AutoCAD.il /output=Interop. AutoCAD.dll

Interop.AutoCAD.res文件是在步骤1中生成的。

5.显然你不愿意每次编写应用程序时都通过上一篇文章中介绍的方法来加入Interop. AutoCAD.dll,那太麻烦了。你可以用下面的方法来让程序自动加入该文件:找到C:\Program Files\Microsoft.NET\ Primary Interop Assemblies 文件夹,然后把上面生成的

Interop.AutoCAD.dll文件拷贝进去。

好了,第二个问题解决了,接下来看第一个。

在VBA中,编程者可以使用GetObject函数来获得当前活动的AutoCAD对象,但在C#中却没有,为了这个函数我几乎把MSDN给翻遍了,然后去各种C#论坛问各位高手,结果都没得到解决,呵呵,可能国内使用C#的人比较少吧。还是在老外的论坛上看到了一篇就是讲这个问题的文章才把这个难题给解决了。使用下面的语句就可以获得当前活动的AutoCAD对象了:

(AcadApplication)Marshal.GetActiveObject("AutoCAD.Application.16")

(对于CAD2000和CAD2002,则把16改为15)

当然以上语句必须在AutoCAD打开的情况下才能使用,否则会发生错误,对于AutoCAD没打开的情况,可以使用上一篇文章的方法来处理。完整的连接AutoCAD与C#的源程序如下所示:

using System;

using AutoCAD;

using System.Runtime.InteropServices;

namespace AcadExample

{

public class AutoCADConnector : IDisposable

{

private AcadApplication _application;

private bool _initialized;

private bool _disposed;

public AutoCADConnector()

{

try

{

// Upon creation, attempt to retrieve running instance

_application = (AcadApplication)Marshal.GetActiveObject("AutoCAD.Application.16");

}

catch

{

try

{

// Create an instance and set flag to indicate this

_application = new AcadApplicationClass();

_initialized = true;

}

catch

{

throw;

}

}

}

// If the user doesn't call Dispose, the

// garbage collector will upon destruction

~AutoCADConnector()

{

Dispose(false);

}

public AcadApplication Application

{

get

{

// Return our internal instance of AutoCAD

return _application;

}

}

// This is the user-callable version of Dispose.

// It calls our internal version and removes the

// object from the garbage collector's queue.

public void Dispose()

{

Dispose(true);

GC.SuppressFinalize(this);

}

// This version of Dispose gets called by our

// destructor.

protected virtual void Dispose(bool disposing)

{

// If we created our AutoCAD instance, call its

// Quit method to avoid leaking memory.

if(!this._disposed && _initialized)

_application.Quit();

_disposed = true;

}

}

}

利用Visual Studio.net 把上面的程序编译成一个类库,你就可以在以后的程序中使用它了,下面的这个例子说明了它的用法。(首先把AcadExample类库包含在项目中)

using System;

using AcadExample;

using AutoCAD;

namespace ConsoleApplication6

{

class Class1

{

[STAThread]

static void Main(string[] args)

{

using (AutoCADConnector connector = new AutoCADConnector())

{

Console.WriteLine(connector.Application.ActiveDocument.Name);

}

Console.ReadLine();

}

}

}

这个例子是在C#窗口中显示AutoCAD中当前文档的标题。


在C#中使用ObjectDBX技术从未打开图形中获得图块的信息


在C#中使用ObjectDBX技术从未打开图形中获得图块的信息

从未打开图形中能获得图块的信息吗?回答是肯定的。下面就来说明具体的实现方法。

要求:

n 会用C#编程

n 读过我写的“利用C#进行AutoCAD的二次开发”

开始:

n 在visual studio.net中新建一C#控制台程序

n 在引用选项卡中添加下列类库:

l interop.AutoCAD.dll

l AcadExample.dll

l ObjectDBX16(在“解决方案资源管理器”中右击“引用”标签,在弹出的菜单中选择“添加引用”,在“添加引用”对话框中选择“com"选项卡下的下拉列表框中的“AutoCAD/ObjectDBX Common 16.0 Type Library"项)

然后键入以下代码:

1: using System;

2: using AutoCAD;

3: using dbx = AXDBLib;

4: using AcadExample;

5:

6: namespace ConsoleApplication1

7: {

8: /// <summary>

9: /// Summary description for Class1.

10: /// </summary>

11: class Class1

12: {

13: /// <summary>

14: /// The main entry point for the application.

15: /// </summary>

16: [STAThread]

17: static void Main(string[] args)

18: {

19: using (AutoCADConnector connector = new AutoCADConnector())

20: {

21: string progid = "ObjectDBX.AxDbDocument.16"

//注意,这是AutoCAD2004的写法,

//若是AutoCAD2002和AutoCAD2000i是”ObjectDBX.AxDbDocument.1“

22: AcadApplication acadApp = connector.Application;

23: dbx.AxDbDocument dbxDoc;

24: dbxDoc = (dbx.AxDbDocument)acadApp.GetInterfaceObject(progid);

25: dbxDoc.Open(@"F:\Test.dwg");

26: foreach (dbx.AcadEntity entity in dbxDoc.ModelSpace)

27: {

28: if (entity.EntityName == "AcDbBlockReference")

//判断实体是否是块参照

29: {

30: dbx.AcadBlockReference blkRef;

31: blkRef = (dbx.AcadBlockReference)entity;

//将是块参照的实体强制转换为块参照类型

32: object[] atts = (object[])blkRef.GetAttributes();

//获取块参照中的属性(为对象类型)

33: for (int i = 0; i < atts.Length; i++) //遍历块参照属性

34: {

35: dbx.AcadAttributeReference att;

36: att = (dbx.AcadAttributeReference)atts[i];

//将块参照属性(对象类型)强制转换为块参照属性类型

37: Console.WriteLine("Tag: {0}\tValue: {1}\n",

38: att.TagString,

39: att.TextString);//显示块参照属性的Tag和Text的值

40: }

41: }

42: }

43: Console.ReadLine();

44: }

45: }

46: }

47: }

第一个要注意的是第三行,使用了一个别名。因为AutoCAD和ObjectDBX命名空间有许多相同的类名,因此,你必须使用全名,而不能使用简写的形式,但ObjectDBX写起来比较麻烦,所以用别名dbx来使输入方便一些。

程序前面部分的代码,你可以参考我写的“利用C#进行AutoCAD的二次开发“这篇文章。让我们来看第21行,程序定义了一个字符串progid,作为第24句的函数GetInterfaceObject的参数,该函数是用来产生一个AxDbDocument对象。但要注意, GetInterfaceObject函数返回的类型是object,所以你必须用强制转换把它变为AxDbDocument类。然后在第25行使用24行产生的AxDbDocument对象来”打开“一个.dwg文件(其实没有打开),需要注意的是这个文件的路径必须是正确的。这个文件就是我们要获得的块信息所在的文件。

由于ObjectDBX 没有选择集,所以只有通过遍历文件的模型空间来获得块的信息(26-28行)。

余下语句的说明我已经写在程序的注释中了。

你可以发现ObjectDBX的工作原理在C#中与VBA是类似的,只不过要进行必要的类型转换。

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
蓝色力量注:
对于文章中提到的对于Interop. AutoCAD.dll需要反编译、修改、再编译的过程,在VS2005中已经不需要这样操作,VS2005已经把private改成了public。


展开阅读全文

没有更多推荐了,返回首页